#!/bin/sh

#cleaning script. clean all files from IDES, all temporary files...



clean_directory() {
 
 directory=$1
 (cd $1;
 #echo -n "=============cleaning  ==========" 
 ({
 echo -n "cleaning "; pwd
 for file in .*
 do
  if [ -d "$file" ]
  then
   	if [ "$file" != "." -a $file != ".." ]
   	then 	
    	 rm -rf $file
   	fi
  else
	#FIXMEE, leave Eclipse files in main directory. (else you can have a problem with eclipse)
   	#if [ "$file" != ".cdtproject" -a $file != ".project" ]
   	#then 	
    	 rm -f $file
   	#fi
  fi
 done

 for file in *~ *.tag *.kdevses *.kdevelop* *.symvers *.log *.tar.gz
 do 
   rm -f $file
 done

 for dir in *
 do
  if [ -d "$dir" ]
  then
   clean_directory $dir
  fi

 done
 })
 )
}

echo -e "\ncleaning\n"
make -k clean
clean_directory "."
