<?php

/**
 * Nedoresene otazky:
 * podporovat soubory nulove delky?? (zatim,ano)
 * co vsecko zakazat za jmena?? (jak to resit)
 * Na prozatimni zkouseni je tohle funkcni...
 */


$DIRECTORY_ROOT = ".";

/** Include basic configuration */
require_once "$DIRECTORY_ROOT/config/config.php";

/** Include language translations needed */
require_once "$DIRECTORY_ROOT/config/language.php";

/** Include db for connecting to the database */
require_once "$DIRECTORY_ROOT/lib/dblib.php";
$db = new DbLibMySQL();
$db->init($db_server,3306, $db_user, $db_pass, $db_database);
$db->OpenConnection();
$ROOT_DIRECTORY_ID = $db->GetFirstRelation("select id from dirs where name = '$ROOT_DIRECTORY_NAME'");
if (!$ROOT_DIRECTORY_ID) {
	echo "Panic! [No root dir]";
	die();
}

/** Include fucntions for attaching and manipulating  */
require_once "$DIRECTORY_ROOT/lib/mysqlfs.php";

$ACTION = addslashes (get_arr_index($_GET,'action'));


if ($ACTION == 'download_file') {
	$res = mysqlfs_get_file(get_arr_index($_GET,'id'));
	if (!$res['bool']){
		$err_mes = $res['err_text']; 
	}
}

?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8">
  <link rel="stylesheet" type="text/css" href="./css/freetime.css">

  <title>Mysql FS php frontend :-)</title>
  </head>
  <body>
<?php









switch ($ACTION) {
	case "add_file" : 
		$res = mysqlfs_add_file($_POST['dir_id'],$_FILES['file']['tmp_name'], common_translate_national_chars($_FILES['file']['name']), $db);
		if (!$res['bool']) {	
			echo "<font color='red'>ERROR: ". $res['err_text']."</font>";
		}
	break;
	case "show_form_add" : 
		mysqlfs_show_form_add_file("?action=add_file", get_arr_index($_GET,'id'));
		
	break;	
	case "download_file" : 
		echo "<font color='red'>ERROR: ". $err_mes."</font>";
	break;	
	case "add_dir" : 
		mysqlfs_add_dir($_POST['parent_dir_id'], $_POST['new_dir_name']);
	break;	
	case "delete_dir" : 
		mysqlfs_delete_dir($_GET['id']);
	break;	
	case "delete_file" : 
		mysqlfs_delete_file($_GET['id']);
	break;	
	default :
		//nothing;
	break;
}

 mysqlfs_show_fs_tree($ROOT_DIRECTORY_ID);

?>
  </body>
</html>