<?php

class DbLib
{

    var                $mHost            = 'localhost';
    var                $mPort            =  3306;
    var                $mUser            = 'root';
    var                $mPassword        = '';
    var                $mDatabase        = 'db';
    var                $mSocket;
    var                $mResult;
    var                $mRow;

    function OpenConnection()   {        $this->mSocket  =  1;                }
    function SelectDatabase()   {        $this->IsConnected();                }
    function DbQuery()          {        $this->IsConnected();                }
    function Query()            {        $this->IsConnected();                }
    function GetResult()        {        $this->IsConnected();                }
    function GetNumRows()       {        $this->IsConnected();                }
    function GetNextRecord()    {        $this->IsConnected();                }
    function GetField()         {        $this->IsConnected();                }
    function GetFirstRelation() {        $this->IsConnected();                }
	function GetLastId()        {        $this->IsConnected();                }
    function FreeResult()       {        $this->IsConnected();                }
    function CloseConnection()  {        $this->IsConnected();                }
    function GetError()         {        $this->IsConnected();                }
    function SqlCorrection()    {        $this->IsConnected();                }
    function __wakeup()         {        $this->OpenConnection();             }
    function __sleep()          {        $this->CloseConnection();            }
    function IsConnected() {
        if (!$this->mSocket) die('Not connected to database server');
    }

}

///////////////////////////////////////////////////////////////////////////////
// MySQL database support
class DbLibMySQL extends DbLib
{

    function init($host, $port, $user, $password, $database)
    {
        if ($host)      $this->mHost      = $host;
        if ($port)      $this->mPort      = $port;
        if ($user)      $this->mUser      = $user;
        if ($password)  $this->mPassword  = $password;
        if ($database)  $this->mDatabase  = $database;
    }
    
    function OpenConnection()
    {
        parent::OpenConnection();
        $this->mSocket = @mysql_connect($this->mHost . ':' . $this->mPort, $this->mUser, $this->mPassword)
            or die($this->GetError());
        @mysql_select_db($this->mDatabase,$this->mSocket)
            or die($this->GetError());
        global $setnames;
        if (!$setnames)
       	  $this->Query('SET NAMES utf8');
       	else
       	  $this->Query("SET NAMES '$setnames'");
        return $this->mSocket;
    }


    function SelectDatabase($database = '')
    {
        parent::SelectDatabase();
        @mysql_select_db($database,$this->mSocket) or die($this->GetError());
        $this->mDatabase = $database;
    }


    function DbQuery($query = '')
    { 
        parent::DbQuery();
        @mysql_unbuffered_query($query,$this->mSocket) or die($this->GetError());
    }


    function Query($query = '')
    {
        parent::Query();
        ($this->mResult = mysql_query($query,$this->mSocket )) or die($this->GetError()) ;
        return $this->mResult;
    }


    function GetResult($row = 0, $coll = 0, $result = 0)
    {
        parent::GetResult();
        ($result) ? $temp_result = $result : $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while getting results');
        return @mysql_result($temp_result,$row,$coll);
    }


    function GetNumRows($result = 0)
    {
        parent::GetNumRows();
        ($result) ? $temp_result = $result : $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while getting results');
        return @mysql_num_rows($temp_result);
    }
	function GetLastId()
    {
        parent::GetLastId();
        return mysql_insert_id();
    }


    function GetNextRecord($result = 0)
    {
        parent::GetNextRecord();
        ($result) ? $temp_result = $result : $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while getting results');
        $this->mRow = @mysql_fetch_assoc($temp_result);
        return $this->mRow != FALSE;
    }


    function GetField($field = '')
    {
        parent::GetField();
        return $this->mRow[$field];
    }


    function FreeResult($result = 0)
    {
        parent::FreeResult();
        if ($result) $temp_result = $result;
        else              $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while freeing results');
        @mysql_free_result($temp_result);
    }


    function SqlCorrection($string)
    {
        parent::SqlCorrection();
        return @mysql_real_escape_string($string);
    }


    function GetError()
    {
        $error = @mysql_error();
        $this->DbQuery('UNLOCK TABLES');
        parent::GetError();
        return $error;
    }


    function CloseConnection()
    {
        $this->DbQuery('UNLOCK TABLES');
        parent::CloseConnection();
        @mysql_close($this->mSocket) or die('There is no valid MySQL-Link resource');
    }

    function GetFetchRow($result = 0)
    {
        parent::GetResult();
        ($result) ? $temp_result = $result : $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while getting results');
        return @mysql_fetch_row($temp_result);
    }
    
    function GetFetchAssoc($result = 0)
    {
        parent::GetResult();
        ($result) ? $temp_result = $result : $temp_result = $this->mResult;

        if (!is_resource($temp_result))
          die('Not MySQL resource while getting results');
        return @mysql_fetch_assoc($temp_result);
    }
    
	function GetFirstRelation($query)
    {
        parent::GetFirstRelation();
        $this->Query($query);
		$retarr = $this->GetFetchRow();
		if (!is_array($retarr)) {
			return null;
		}
		return $retarr[0];
    }
}
?>
