#!/bin/sh
#startfs.sh
#shell script to start fs


#rebuild all

rebuild() {
make clean;
if ! make
 then
 echo "WARNING: Can not build filesystem is this OK?";
 return 1;
 else
 echo "DONE OK"

fi
}


stopfs() {
echo "============= GOINING TO SHUT DOWN FILESYSTEM"

echo "---- killing deamon----";
if ! (ps -e | grep fsd_deamon$ | sed "s/^\( \)*//g"|cut -f1 -d" " | xargs kill -2 > /dev/null 2>&1)
 then
 echo "WARNING Can not kill the deamon ... Already killed by system?";
 else
 echo "DONE OK"

fi

echo "---- umounting filesystem----";
if ! (cd kernel_module; ./umount.sh)
 then
 echo "Can umount filesystem ... Exiting...";
 exit 1;
 else
 echo "DONE OK"

fi

echo "---- uload module----";
if ! (cd kernel_module; ./uload.sh)
 then
 echo "Can umount filesystem ... Exiting...";
 exit 1;
 else
 echo "DONE OK"
fi
}


# escape 
trap stopfs 2
echo "============= CHECK ROOT USER"
if [ ! $EUID -eq 0 ]
 then
 echo "You are not logged as root.Can not load fs";
 exit 1;
 else
 echo "DONE OK"

fi


echo "============= CHECKING FOR DEAMON"
if [ ! -x "deamon/fsd_deamon" ]
 then
 echo "Deamon is not executable. Exiting...";
 exit 1;
 else
 echo "DONE OK"

fi

echo "============= CHECKING FOR LOAD SCRIPT"
if [ ! -x "kernel_module/load.sh" ]
 then
 echo "Load script is not executable. Exiting...";
 exit 1;
 else
 echo "DONE OK"

fi


echo "============= CHECKING FOR MOUNT SCRIPT"
if [ ! -x "kernel_module/mount.sh" ]
 then
 echo "Mount script is not executable. Exiting...";
 exit 1;
 else
 echo "DONE OK"

fi

echo "============= CHECKING FOR ULOAD SCRIPT"
if [ ! -x "kernel_module/uload.sh" ]
 then
 echo "Uload script is not executable. Exiting...";
 exit 1;
 else
 echo "DONE OK"

fi


echo "============= CHECKING FOR UMOUNT SCRIPT"
if [ ! -x "kernel_module/umount.sh" ]
 then
 echo "Umount script is not executable. Exiting...";

 exit 1;
 else
 echo "DONE OK"

fi




echo -e "\n\n\n=============LOADING THE MODULE"


if ! ( cd kernel_module; ./load.sh )
 then
 echo "Can not load module... Exiting...";
 exit 1;
 else
 echo "DONE OK"
fi


echo "=============MOUNTING FILESYSTEM"


if !  (cd kernel_module; ./mount.sh & )
 then
 echo "Can not mount filesystem... Exiting...";
echo "---- umounting filesystem----";
  if ! (cd kernel_module; ./umount.sh)
   then
   echo "Can umount filesystem ... Exiting...";
   exit 1;
   else
   echo "DONE OK"
   exit 1;
 fi
  else
   echo "DONE OK"
fi




echo "=============STARTING DEAMON"

echo "Log you can see in deamon.log";
echo -e "\n\n\nFILESYSTEM IS NOW RUNNING..."
echo "if you want to stop filesystem try C^C on this script"
# FIXME deamon should run not as root program
if ! (  cd deamon; echo "" > deamon.log; ./fsd_deamon >> deamon.log 2>&1 )
 then
 echo " Deamon: not running (probably already killed It's OK)... ";
 exit 1;
fi
